variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  
  GIT_DEPTH: "0" 
  IMAGE_NAME: "ecom-frontend-image"

stages:
  - Test
  - Static Application Security Testing (SAST)
  - Build the docker images and push the artefact
  - trigger

Test:
  stage: Test
  image: node:latest 
  script:
    - npm install --silent
    - npm test --silent

Static Application Security Testing (SAST):
  stage: Static Application Security Testing (SAST)
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner 

Build the docker images and push the artefact:
  stage: Build the docker images and push the artefact
  image: docker:latest
  services:
    - docker:dind
  script:
    - apk add --no-cache python3 py3-pip
    - python3 -m venv /venv
    - source /venv/bin/activate
    - pip install requests
    - wget -qO- https://github.com/aquasecurity/trivy/releases/download/v0.24.0/trivy_0.24.0_Linux-64bit.tar.gz | tar xvz
    - mv trivy /usr/local/bin/
    - python script.py $IMAGE_NAME $PERSONAL_ACCES_TOKEN
    - deactivate

trigger_pipeline_job:
  stage: trigger
  script:
    - 'curl --fail --request POST --form variables[PIPELINE_SENDER]=frontend --form token=glptt-9525bacd78fce3e3cae0c115e97b5dd7062c5f18 --form ref=main "https://gitlab.com/api/v4/projects/57197002/trigger/pipeline"'

